% Adds a new Statistics value ID to the selected spots component
vLib = ImarisLib;
vImaris = vLib.GetApplication(0);

if isequal(vImaris, [])
  display('Could not connect to Imaris')
  return
end

vSelection = vImaris.GetSurpassSelection;

vSpots = vImaris.GetFactory.ToSpots(vSelection);
vSurfaces = vImaris.GetFactory.ToSurfaces(vSelection);
vCategory = '';
if isequal(vSpots, []) && isequal(vSurfaces, [])
  display('No spots or surfaces selected')
  return
end

vComponentName = char(vSelection.GetName);
vNumberOfItems = 0;

vItemIndicesT = zeros(vNumberOfItems,1);
if ~isequal(vSpots, [])
  vItemIndicesT = vSpots.GetIndicesT;
  vNumberOfItems = size(vItemIndicesT,1);
  vCategory = 'Spot';
end

if ~isequal(vSurfaces, [])
  vCategory = 'Surface';
  vNumberOfItems = vSurfaces.GetNumberOfSurfaces();
  for vSurfaceIndex = 1:vNumberOfItems
    vItemIndicesT(vSurfaceIndex) = vSurfaces.GetTimeIndex(vSurfaceIndex-1);
  end
end

vTemplate = cell(vNumberOfItems,1);

vNames = vTemplate;
vValues = (0:vNumberOfItems-1)';
vUnits = cell(vNumberOfItems,1);
vFactors = cell(2, vNumberOfItems);
vFactorNames = {'Category'; 'Time'};
vIDs = (0:vNumberOfItems-1)';

for i=1:vNumberOfItems
  vNames{i} = 'ID';
  vUnits{i} = '';
  vFactors{1,i} = vCategory;
  vFactors{2,i} = char(num2str(vItemIndicesT(i))+1);
end


vSelection.AddStatistics(vNames, vValues, vUnits, vFactors, vFactorNames, vIDs);

sprintf('Added Statistics named ID to the %d %ss of %s', vNumberOfItems, vCategory, vComponentName);